#include <cstdio>
#include <cstdlib>
#include "isvd.h"

int main(){
	const int N = 500; // Matrix size
	const int P = 4; // Number of threads
	const int count_to_show = 5;
	double *diag, *subdiag, *U, *V, *work;
	int *UvecsOrder, *VvecsOrder, *iwork;
	int i, j;
	
	diag = (double*)malloc(sizeof(double) * N);
	subdiag = (double*)malloc(sizeof(double) * N);
	U = (double*)malloc(sizeof(double) * N * N);
	V = (double*)malloc(sizeof(double) * N * N);
	work = (double*)malloc(sizeof(double) * GetWorkSize(N, 0, P, 0));
	UvecsOrder = (int*)malloc(sizeof(int) * N);
	VvecsOrder = (int*)malloc(sizeof(int) * N);
	iwork = (int*)malloc(sizeof(int) * GetWorkSize(N, 0, P, 10));
	
	// Set the matrix
	srand(0);
	for(i = 0; i < N; i++){
		diag[i] = (double)rand() / (double)RAND_MAX - 0.5; // Set diagonal elements
	}
	for(i = 0; i < N - 1; i++){
		subdiag[i] = (double)rand() / (double)RAND_MAX - 0.5; // Set subdiagonal elements
	}

	// Singular value decomposition with I-SVD
	DBDSLV(N, diag, subdiag, U, V, UvecsOrder, VvecsOrder, work, iwork, P, 0);

	// Show the answer partly
	printf("Singular values = \n");
	for(i = 0; i < count_to_show; i++){
		printf("%le\n", diag[i]);
	}
	printf("Matrix U = \n");
	for(i = 0; i < count_to_show; i++){
		for(j = 0; j < count_to_show; j++){
			printf("%le, ", U[UvecsOrder[j] * N + i]);
		}
		printf("\n");
	}
	printf("Matrix V = \n");
	for(i = 0; i < count_to_show; i++){
		for(j = 0; j < count_to_show; j++){
			printf("%le, ", V[VvecsOrder[j] * N + i]);
		}
		printf("\n");
	}
	
	free(diag); free(subdiag); free(U); free(V); free(work);
	free(UvecsOrder); free(VvecsOrder); free(iwork);
}
